#include "Cursor.h"

#include "SDL.h"
#include "SDL_image.h"
#include <iostream>

#include "Definicions.h"


using namespace std;


Cursor::Cursor(SDL_Surface* imatge, SDL_Surface* superficie)
{
    mSuperficie = superficie;
    mImgCursor = imatge;

    mOrigenTaulerX = RESX - MIDA_PECA*MIDA_TAULER;
    mOrigenTaulerY = 0;

    mPosicio.w = MIDA_PECA;
    mPosicio.h = MIDA_PECA;

    mCursorOri.x = mCursorOri.y = 0;
    mCursorOri.w = mCursorOri.h = MIDA_PECA;
}


Cursor::~Cursor()
{
}


void Cursor::Inicialitza()
{
    mPosicio.x = mOrigenTaulerX + 4*MIDA_PECA;
    mPosicio.y = mOrigenTaulerY + 4*MIDA_PECA;
}


void Cursor::Pinta()
{
    SDL_BlitSurface(mImgCursor, &mCursorOri, mSuperficie, &mPosicio);
}


bool Cursor::Esquerra()
{
    if (mPosicio.x >= mOrigenTaulerX + MIDA_PECA)
    {
        mPosicio.x -= MIDA_PECA;
        return true;
    }
    else
        return false;
}


bool Cursor::Dreta()
{
    if (mPosicio.x <= mOrigenTaulerX + MIDA_PECA*(MIDA_TAULER-2))
    {
        mPosicio.x += MIDA_PECA;
        return true;
    }
    else
        return false;
}


bool Cursor::Amunt()
{
    if (mPosicio.y >= mOrigenTaulerY + MIDA_PECA)
    {
        mPosicio.y -= MIDA_PECA;
        return true;
    }
    else
        return false;
}


bool Cursor::Avall()
{
    if (mPosicio.y <= mOrigenTaulerY + MIDA_PECA*(MIDA_TAULER-2))
    {
        mPosicio.y += MIDA_PECA;
        return true;
    }
    else
        return false;
}

void Cursor::mousePosition(int x, int y)
{

 

for (int i=0; i<=MIDA_TAULER; i++)
{
if (x < (mOrigenTaulerX + i*MIDA_PECA))
	{ x=(i-1)*MIDA_PECA + mOrigenTaulerX;
	break;
	}
}

for (int i=0; i<= MIDA_TAULER; i++)
{
if (y < mOrigenTaulerY + i*MIDA_PECA)
	{ y=(i-1)*MIDA_PECA + mOrigenTaulerY;
	break;
	}
}


if (y > mOrigenTaulerY-1 && y < MIDA_TAULER*MIDA_PECA) mPosicio.y=y;
if (x > mOrigenTaulerX-1 && x < MIDA_TAULER*MIDA_PECA+mOrigenTaulerX) mPosicio.x=x;

}


