#include "GestorPecesIntro.h"

#include "SDL.h"
#include <iostream>
#include <math.h>
#include <time.h>
#include <stdlib.h>
#include <ctype.h>

using namespace std;


GestorPecesIntro::GestorPecesIntro(SDL_Surface* imgPeces, SDL_Surface* superficie)
{
    mImgPeces = imgPeces;
    mSuperficie = superficie;

    mTempsNovaPeca = SDL_GetTicks();

    srand(time(NULL));
    mPeces[0] = new PecaIntro(rand()%(RESX-MIDA_PECA_RESTANT), RESY, 1 + (rand() % 7), mImgPeces, mSuperficie);
    for (Uint8 i=1; i<MAX_PECES_INTRO; i++)
        mPeces[i] = NULL;

}

GestorPecesIntro::~GestorPecesIntro()
{
    for (Uint8 i=0; i<MAX_PECES_INTRO; i++)
        if (mPeces[i]!=NULL) delete mPeces[i];
}


void GestorPecesIntro::Actualitza()
{
    if (SDL_GetTicks()-mTempsNovaPeca>1500)
    {
        bool trobat=false;
        Uint8 i;

        for (i=0; i<MAX_PECES_INTRO && !trobat; i++)
            trobat = (mPeces[i]==NULL);

        if (trobat)
        {
            mPeces[--i] = new PecaIntro(rand()%(RESX-MIDA_PECA), RESY, 1 + (rand() % 7), mImgPeces, mSuperficie);
            mTempsNovaPeca = SDL_GetTicks()-(Uint32)(rand()%1300);
        }
    }

    for (Uint8 i=0; i<MAX_PECES_INTRO; i++)
    {
        if (mPeces[i]!=NULL)
        {
            mPeces[i]->Actualitza();
            if (mPeces[i]->DonaEstat()==PecaIntro::MORTA)
            {
                delete mPeces[i];
                mPeces[i]=NULL;
            }
        }
    }
}


void GestorPecesIntro::Pinta()
{
    for (Uint8 i=0; i<MAX_PECES_INTRO; i++)
        if (mPeces[i]!=NULL) mPeces[i]->Pinta();
}
