#include "Motor.h"
#include <iostream>
#include <stdlib.h>
#include "Definicions.h"


using namespace std;


Motor::Motor()
{
    mSuperficie = NULL;
    mTitol = NULL;
    mAmplada = 320;
    mAlcada = 240;
    mProfunditat = 16;
    mUltimTick = 0;
    mFPS = 0;
    mComptadorFPS = 0;
    mComptadorTicksFPS = 0;
}


Motor::~Motor()
{
    SDL_Quit();
}


void Motor::PosaMida(const Uint16& amplada, const Uint16& alcada, const Uint16& profunditat)
{
    mAmplada = amplada;
    mAlcada = alcada;
    mProfunditat = profunditat;
}


void Motor::Inicialitza()
{
cout << "1" << endl;
    atexit(SDL_Quit);
cout << "X" << endl;

    if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_TIMER) < 0)

    {
        cerr << "Error inicialitzant SDL: " << SDL_GetError() << endl;
        exit(1);
    }

cout << "2" << endl;

    SDL_ShowCursor(SDL_DISABLE);
cout << "3" << endl;

    PosaMida(mAmplada, mAlcada, mProfunditat);
    mSuperficie = SDL_SetVideoMode(mAmplada, mAlcada, mProfunditat, SDL_SWSURFACE);
//    mSuperficie = SDL_SetVideoMode(mAmplada, mAlcada, mProfunditat, SDL_SWSURFACE);
//    mSuperficie = SDL_SetVideoMode(mAmplada, mAlcada, mProfunditat, SDL_HWSURFACE|SDL_DOUBLEBUF);

    SDL_WM_SetCaption(mTitol, 0);

    if (mSuperficie == NULL)
    {
        cerr << "Error creant la finestra: " << SDL_GetError() << endl;
        exit(1);
    }

    InicialitzaExtra();
}


void Motor::Inicia()
{
    mUltimTick = SDL_GetTicks();
    mSurt = false;

    while (!mSurt)
    {
        GestionaInput();
        FesActualitza();
        FesPinta();
    }

    Finalitza();
}


void Motor::GestionaInput()
{
    SDL_Event event;

    while(SDL_PollEvent(&event))
    {
        switch(event.type)
        {
            case SDL_KEYDOWN: TeclaAvall(event.key.keysym.sym); break;
	    case SDL_KEYUP: TeclaAmunt(event.key.keysym.sym); break;
	    case SDL_MOUSEBUTTONDOWN: mouseDown(event.button.x, event.button.y); break;
	    case SDL_MOUSEBUTTONUP: mouseUp(event.button.x, event.button.y); break;

        }
    }
}


void Motor::FesActualitza()
{
    Uint32 tempsTranscorregut = SDL_GetTicks() - mUltimTick;
    mUltimTick = SDL_GetTicks();

    Actualitza();

    mComptadorTicksFPS += tempsTranscorregut;
}


void Motor::FesPinta()
{
    ++mComptadorFPS;
    if (mComptadorTicksFPS >= 1000)
    {
        mFPS = mComptadorFPS;
        mComptadorFPS = 0;
        mComptadorTicksFPS = 0;
    }

    if (SDL_MUSTLOCK(mSuperficie))
        if (SDL_LockSurface(mSuperficie) < 0)
            return;

    Pinta();

    if (SDL_MUSTLOCK(mSuperficie))
        SDL_UnlockSurface(mSuperficie);

    SDL_Flip(mSuperficie);
}


void Motor::PosaTitol(const char* titol)
{
    mTitol = titol;
}


const char* Motor::DonaTitol()
{
    return mTitol;
}


SDL_Surface* Motor::DonaSuperficie()
{
    return mSuperficie;
}


Uint8 Motor::DonaFPS()
{
    return mFPS;
}
