#ifndef MOTOR_H
#define MOTOR_H

#include "SDL.h"


class Motor
{
    public:

        Motor();
        virtual ~Motor();

        void Inicialitza();
        void Inicia();

        virtual void InicialitzaExtra() {};
        virtual void Finalitza() {};

        virtual void Actualitza() {};
        virtual void Pinta() {};

#ifdef TARGET_GP2X
        virtual void TeclaAvall(const Uint8& tecla) {};
        virtual void TeclaAmunt(const Uint8& tecla) {};
#else
        virtual void TeclaAvall(const SDLKey& tecla) {};
        virtual void TeclaAmunt(const SDLKey& tecla) {};
	
#endif

virtual void mouseDown(int x, int y) {};
virtual void mouseUp(int x, int y) {};

        void PosaTitol(const char* titol);
        const char* DonaTitol();

        void PosaMida(const Uint16& amplada, const Uint16& alcada, const Uint16& profunditat);

        SDL_Surface* DonaSuperficie();

        Uint8 DonaFPS();

    protected:

        void FesActualitza();
        void FesPinta();

        void GestionaInput();

        SDL_Surface* mSuperficie;

        bool mSurt;

    private:

        Uint16 mAmplada, mAlcada, mProfunditat;

        Uint8 mFPS;
        Uint8 mComptadorFPS;
        Uint16 mComptadorTicksFPS;

        const char* mTitol;

        Uint32 mUltimTick;
};


#endif // MOTOR_H
