#include "MotorTilematch.h"

#include "SDL.h"
#include "SDL_image.h"
#include <iostream>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <ctype.h>
#ifdef TARGET_GP2X
#    include <unistd.h>
#endif


using namespace std;

int numberOfPieces;
int selectedX;
int selectedY;
char sNovaPartida[5][15];
char sModeJoc[5][16];
char sModeNormal[5][8];
char sModeCent[5][11];
char sModeTemps[5][16];
char sPuntuacions[5][13];
char sTemes[5][7];
char sLlengua[5][10];
char sLlengues[5][11];
char sSortir[5][7];
char sPunts[5][8];
char sNivell[5][7];
char sTemps[5][8];
char sObj[5][5];
char sPausa[5][10];
char sNoMesLinies[5][23];
char sFiPartida[5][19];
char sTitolPuntuacions[5][26];
char sInfoIntroNomL1[5][23];
char sInfoIntroNomL2[5][20];
char sInfoIntroNomL3[5][20];
char sInfoRecordsL1[5][28];
char sInfoRecordsL2[5][39];
char sInfoRecordsL3[5][31];
char sCarregant[5][13];

void MotorTilematch::InicialitzaExtra()
{
    mLlengua = 0;
    FILE* arxiu = fopen("data/llengua.tlm", "rb");
    if (arxiu == NULL)
    {
        cerr << "Error llegint <data/llengua.tlm>" << endl;
        exit(1);
    }
    fread( &mLlengua, sizeof(mLlengua), 1, arxiu);
    fclose(arxiu);

    {
        sprintf(sNovaPartida[CAT], "NOVA PARTIDA");
        sprintf(sNovaPartida[EUS], "PARTIDA BERRIA");
        sprintf(sNovaPartida[GAL], "NOVA PARTIDA");
        sprintf(sNovaPartida[CAS], "NUEVA PARTIDA");
        sprintf(sNovaPartida[ANG], "START GAME");
        sprintf(sModeJoc[CAT], "MODE DE JOC");
        sprintf(sModeJoc[EUS], "JOKATZEKO MODUA");
        sprintf(sModeJoc[GAL], "MODO DE XOGO");
        sprintf(sModeJoc[CAS], "MODO DE JUEGO");
        sprintf(sModeJoc[ANG], "GAME MODE");
        sprintf(sModeNormal[CAT], "NORMAL");
        sprintf(sModeNormal[EUS], "NORMALA");
        sprintf(sModeNormal[GAL], "NORMAL");
        sprintf(sModeNormal[CAS], "NORMAL");
        sprintf(sModeNormal[ANG], "NORMAL");
        sprintf(sModeCent[CAT], "100 PECES");
        sprintf(sModeCent[EUS], "100 PIEZA");
        sprintf(sModeCent[GAL], "100 PEZAS");
        sprintf(sModeCent[CAS], "100 PIEZAS");
        sprintf(sModeCent[ANG], "100 TILES");
        sprintf(sModeTemps[CAT], "CONTRA RELLOTGE");
        sprintf(sModeTemps[EUS], "ERLOJUPEKO");
        sprintf(sModeTemps[GAL], "CONTRARRELOXO");
        sprintf(sModeTemps[CAS], "CONTRARRELOJ");
        sprintf(sModeTemps[ANG], "TIME TRIAL");
        sprintf(sTemes[CAT], "TEMES");
        sprintf(sTemes[EUS], "TEMAS");
        sprintf(sTemes[GAL], "TEMAS");
        sprintf(sTemes[CAS], "TEMAS");
        sprintf(sTemes[ANG], "THEMES");
        sprintf(sPuntuacions[CAT], "PUNTUACIONS");
        sprintf(sPuntuacions[EUS], "PUNTUAZIOAK");
        sprintf(sPuntuacions[GAL], "PUNTUACIONS");
        sprintf(sPuntuacions[CAS], "PUNTUACIONES");
        sprintf(sPuntuacions[ANG], "SCORES");
        sprintf(sLlengua[CAT], "LLENGUA");
        sprintf(sLlengua[EUS], "HIZKUNTZA");
        sprintf(sLlengua[GAL], "LINGUA");
        sprintf(sLlengua[CAS], "LENGUA");
        sprintf(sLlengua[ANG], "LANGUAGE");
        sprintf(sSortir[CAT], "SORTIR");
        sprintf(sSortir[EUS], "IRTEN");
        sprintf(sSortir[GAL], "SAIR");
        sprintf(sSortir[CAS], "SALIR");
        sprintf(sSortir[ANG], "EXIT");
        sprintf(sPunts[CAT], "PUNTS");
        sprintf(sPunts[EUS], "PUNTUAK");
        sprintf(sPunts[GAL], "PUNTOS");
        sprintf(sPunts[CAS], "PUNTOS");
        sprintf(sPunts[ANG], "SCORE");
        sprintf(sNivell[CAT], "NIVELL");
        sprintf(sNivell[EUS], "MAILA");
        sprintf(sNivell[GAL], "NIVEL");
        sprintf(sNivell[CAS], "NIVEL");
        sprintf(sNivell[ANG], "LEVEL");
        sprintf(sTemps[CAT], "TEMPS");
        sprintf(sTemps[EUS], "DENBORA");
        sprintf(sTemps[GAL], "TIEMPO");
        sprintf(sTemps[CAS], "TIEMPO");
        sprintf(sTemps[ANG], "TIME");
        sprintf(sObj[CAT], "OBJ");
        sprintf(sObj[EUS], "HELB");
        sprintf(sObj[GAL], "OBX");
        sprintf(sObj[CAS], "OBJ");
        sprintf(sObj[ANG], "GOAL");
        sprintf(sPausa[CAT], "PAUSA");
        sprintf(sPausa[EUS], "PAUSALDIA");
        sprintf(sPausa[GAL], "PAUSA");
        sprintf(sPausa[CAS], "PAUSA");
        sprintf(sPausa[ANG], "PAUSE");
        sprintf(sNoMesLinies[CAT], "NO HI HA MES LINIES");
        sprintf(sNoMesLinies[EUS], "EZ DAUDE LINEA GEHIAGO");
        sprintf(sNoMesLinies[GAL], "NON HAI MAIS LINEAS");
        sprintf(sNoMesLinies[CAS], "NO HAY MAS LINEAS");
        sprintf(sNoMesLinies[ANG], "NO MORE LINES");
        sprintf(sFiPartida[CAT], "FI DE LA PARTIDA");
        sprintf(sFiPartida[EUS], "PARTIDAREN AMAIERA");
        sprintf(sFiPartida[GAL], "FIN DA PARTIDA");
        sprintf(sFiPartida[CAS], "FIN DE LA PARTIDA");
        sprintf(sFiPartida[ANG], "GAME OVER");
        sprintf(sLlengues[CAT], "CATALA");
        sprintf(sLlengues[EUS], "EUSKERA");
        sprintf(sLlengues[GAL], "GALEGO");
        sprintf(sLlengues[CAS], "CASTELLANO");
        sprintf(sLlengues[ANG], "ENGLISH");
        sprintf(sTitolPuntuacions[CAT], "POS NOM    PUNTS   NIVELL");
        sprintf(sTitolPuntuacions[EUS], "POS IZENA  PUNT     MAILA");
        sprintf(sTitolPuntuacions[GAL], "POS NOME   PUNTOS   NIVEL");
        sprintf(sTitolPuntuacions[CAS], "POS NOMBRE PUNTOS   NIVEL");
        sprintf(sTitolPuntuacions[ANG], "POS NAME   SCORE    LEVEL");
        sprintf(sInfoIntroNomL1[CAT], "[,\\: MOU CURSOR");
        sprintf(sInfoIntroNomL1[EUS], "[,\\: KURTSOREA MUGITU");
        sprintf(sInfoIntroNomL1[GAL], "[,\\: MOVE CURSOR");
        sprintf(sInfoIntroNomL1[CAS], "[,\\: MUEVE CURSOR");
        sprintf(sInfoIntroNomL1[ANG], "[,\\: MOVE CURSOR");
        sprintf(sInfoIntroNomL2[CAT], "],^: CANVIA LLETRA");
        sprintf(sInfoIntroNomL2[EUS], "],^: LETRA ALDATU");
        sprintf(sInfoIntroNomL2[GAL], "],^: CAMBIA LETRA");
        sprintf(sInfoIntroNomL2[CAS], "],^: CAMBIA LETRA");
        sprintf(sInfoIntroNomL2[ANG], "],^: CHANGE LETTER");
        sprintf(sInfoIntroNomL3[CAT], "A, B, X, Y: ACCEPTA");
        sprintf(sInfoIntroNomL3[EUS], "A, B, X, Y: ONARTU");
        sprintf(sInfoIntroNomL3[GAL], "A, B, X, Y: ACEPTA");
        sprintf(sInfoIntroNomL3[CAS], "A, B, X, Y: ACEPTA");
        sprintf(sInfoIntroNomL3[ANG], "A, B, X, Y: ACCEPT");
        sprintf(sInfoRecordsL1[CAT], "A, B, X, Y: TORNA AL MENU");
        sprintf(sInfoRecordsL1[EUS], "A, B, X, Y: MENURA BUELTATU");
        sprintf(sInfoRecordsL1[GAL], "A, B, X, Y: RETORNA AO MENU");
        sprintf(sInfoRecordsL1[CAS], "A, B, X, Y: VUELVE AL MENU");
        sprintf(sInfoRecordsL1[ANG], "A, B, X, Y: BACK TO MENU");
        sprintf(sInfoRecordsL2[CAT], "L+R: REINICIALITZA PUNTUACIONS");
        sprintf(sInfoRecordsL2[EUS], "L+R: PUNTUAZIOAK 0-TAN JARRI");
        sprintf(sInfoRecordsL2[GAL], "L+R: REINICIALIZA PUNTUACIONS");
        sprintf(sInfoRecordsL2[CAS], "L+R: REINICIALIZA PUNTUACIONES");
        sprintf(sInfoRecordsL2[ANG], "L+R: RESET SCORES");
        sprintf(sInfoRecordsL3[CAT], "[,\\: CANVIA MODE DE JOC");
        sprintf(sInfoRecordsL3[EUS], "[,\\: JOKATZEKO MODUA ALDATU");
        sprintf(sInfoRecordsL3[GAL], "[,\\; TROCA MODO DE XOGO");
        sprintf(sInfoRecordsL3[CAS], "[,\\; CAMBIA MODO DE JUEGO");
        sprintf(sInfoRecordsL3[ANG], "[,\\: CHANGE GAME MODE");
        sprintf(sCarregant[CAT], "CARREGANT...");
        sprintf(sCarregant[EUS], "CARGANDO...");
        sprintf(sCarregant[GAL], "CARGANDO...");
        sprintf(sCarregant[CAS], "CARGANDO...");
        sprintf(sCarregant[ANG], "LOADING...");
    }


    if (Mix_OpenAudio(22050, AUDIO_S16, 1, 512) == -1)

    {
        cerr << "Error obrint el dispositiu d'audio: " << Mix_GetError() << endl;
        exit(1);
    }

    mTemaActual=1;
    mGestorTemes=new GestorTemes();
    mGestorTemes->CarregaFontTema(mTemaActual, &mImgFont, mSuperficie);

    mText = new Text(mImgFont, mSuperficie);
    if (SDL_MUSTLOCK(mSuperficie))
        if (SDL_LockSurface(mSuperficie) < 0)
            return;
    mText->Escriu(RESX>>1, RESY>>1, sCarregant[mLlengua], CENTREH|CENTREV);
    if (SDL_MUSTLOCK(mSuperficie))
        SDL_UnlockSurface(mSuperficie);

    SDL_Flip(mSuperficie);

    mGestorTemes->CarregaTema(mTemaActual, &mImgPeces, &mImgPecesRestants, &mImgFons, &mImgCursor,
                              &mSoMenu, &mSoPuntuacions, &mSoRecord, &mSoCursor, &mSoMarca, &mSoCanvi,
                              &mSoNoCanvi, &mSoDeuSegons, &mSoNoMesLinies, &mSoFiNivell, &mSoFiPartida,
                              &mSoPausa, mSuperficie);

    delete mGestorTemes;
    mGestorTemes=NULL;

    mRequadreInfo.x = 0;
    mRequadreInfo.y = 480;
    mRequadreInfo.w = 480;
    mRequadreInfo.h = 180;
    mRequadreJoc.x = RESX-(MIDA_TAULER*MIDA_PECA);
    mRequadreJoc.y = 0;
    mRequadreJoc.w = MIDA_TAULER*MIDA_PECA;
    mRequadreJoc.h = MIDA_TAULER*MIDA_PECA;

    mPosicioTauler.x = RESX/2 - 68;
    mPosicioTauler.y = RESY/2 - 68 - MIDA_PECA;
    mPosicioTauler.w = mPosicioTauler.h = 135;

    mSeleccionatOri.x = MIDA_PECA;
    mSeleccionatOri.y = 0;
    mSeleccionatOri.w = mSeleccionatOri.h = MIDA_PECA;
    mSeleccionatDest.w = mSeleccionatDest.h = MIDA_PECA;

    mOrigenTaulerX = RESX - MIDA_PECA*MIDA_TAULER;
    mOrigenTaulerY = 0;

    mCursor = new Cursor(mImgCursor, mSuperficie);

    mVolum = MIX_MAX_VOLUME;
    Mix_VolumeMusic(mVolum);
    Mix_Volume(-1, mVolum);



#ifdef TARGET_GP2X
    mJoystick = SDL_JoystickOpen(0);
#endif
    mPuntuacions.Llegeix("data/puntuacions.tlm");

    mEstat = MENU_PRINCIPAL;
    mModeJoc = MODE_JOC_NORMAL;

    for (Uint8 i=0; i<MIDA_TAULERQ; i++) mTauler[i]=NULL;
    for (Uint8 i=0; i<8; i++) mPecesRestants[i].mPeca = new PecaRestant(130+i*(MIDA_PECA_RESTANT+15), (MIDA_TAULER*MIDA_PECA)+35, i+1, mImgPecesRestants, mSuperficie);

    mMilisegonsActA = mMilisegonsAntA = mMilisegonsActP = mMilisegonsAntP = mTempsTecla = SDL_GetTicks();

    mEstat = MENU_PRINCIPAL;
    mOpcioMenu = 0;

    mGestorPecesIntro = new GestorPecesIntro(mImgPecesRestants, mSuperficie);

    mTAmu = mTAva = mTEsq = mTDre = mTAmuEsq = mTAmuDre = mTAvaEsq = mTAvaDre = mTL = mTR = mTVolAmu = mTVolAva = mTStart = mTSelect = mTA = mTB = mTX = mTY = false;
    mFramesTecla = 0;
    mNom[0] = mNom[1] = mNom[2] = 'A'; mNom[3]='\0';

    mRecordActual = -1;

    mMostraFPS = false;
}


void MotorTilematch::Finalitza()
{
    delete mGestorPecesIntro;

    Mix_FreeChunk(mSoPausa); mSoPausa = NULL;
    Mix_FreeChunk(mSoNoMesLinies); mSoNoMesLinies = NULL;
    Mix_FreeChunk(mSoFiPartida); mSoFiPartida = NULL;
    Mix_FreeChunk(mSoDeuSegons); mSoDeuSegons = NULL;
    Mix_FreeChunk(mSoFiNivell); mSoFiNivell = NULL;
    Mix_FreeChunk(mSoNoCanvi); mSoNoCanvi = NULL;
    Mix_FreeChunk(mSoCanvi); mSoCanvi = NULL;
    Mix_FreeChunk(mSoMarca); mSoMarca = NULL;
    Mix_FreeChunk(mSoCursor); mSoCursor = NULL;
    Mix_FreeMusic(mSoRecord); mSoPuntuacions = NULL;
    Mix_FreeMusic(mSoPuntuacions); mSoPuntuacions = NULL;
    Mix_FreeMusic(mSoMenu); mSoMenu=NULL;
    Mix_CloseAudio();

#ifdef TARGET_GP2X
    SDL_JoystickClose(mJoystick);
#endif

    for (Uint8 i=0; i<8; i++) delete mPecesRestants[i].mPeca;

    delete mCursor;
    delete mText;

    for (Uint8 i=0; i<MIDA_TAULERQ; i++)
        if (mTauler[i]!=NULL)
            delete mTauler[i];

    if (mImgFont != NULL) SDL_FreeSurface(mImgFont);
    if (mImgCursor != NULL) SDL_FreeSurface(mImgCursor);
    if (mImgFons != NULL) SDL_FreeSurface(mImgFons);
    if (mImgPecesRestants != NULL) SDL_FreeSurface(mImgPecesRestants);
    if (mImgPeces != NULL) SDL_FreeSurface(mImgPeces);
}


void MotorTilematch::Actualitza()
{
    mMilisegonsActA = SDL_GetTicks();

    if (mMilisegonsActA-mMilisegonsAntA>=SPF)
    {
        switch(mEstat)
        {
            case MENU_PRINCIPAL:        MenuPrincipalA();                     break;
            case MODE_JOC:              ModeJocA();                           break;
            case LLENGUA:               LlenguaA();                           break;
            case INIT_TEMES:            InitTemesA();                         break;
            case TEMES:                 TemesA();                             break;
            case PUNTUACIONS:           PuntuacionsA();                       break;
            case NOVA_PARTIDA:          NovaPartidaA();                       break;
            case NOU_NIVELL:            NouNivellA();                         break;
            case REINICIALITZA_NIVELL:  ReinicialitzaNivellA();               break;
            case JUGANT:                JugantA(); ControlTemps();            break;
            case INTERCANVI:            IntercanviA(); ControlTemps();        break;
            case DESFA_INTERCANVI:      DesfaIntercanviA(); ControlTemps();   break;
            case BUIDANT:               BuidantA(); ControlTemps();           break;
            case BAIXANT:               BaixantA(); ControlTemps();           break;
            case REEMPLACANT:           ReemplacantA(); ControlTemps();       break;
            case NO_MES_LINIES:         NoMesLiniesA();                       break;
            case FI_NIVELL:             FiNivellA();                          break;
            case FI_PARTIDA:            FiPartidaA();                         break;
            case SURT_PARTIDA:          SurtPartidaA();                       break;
	    case RECORD:                RecordA();                            break;
            default:                                                          break;
        }
        mMilisegonsAntA = mMilisegonsActA;
    }
}


void MotorTilematch::Pinta()
{
    mMilisegonsActP = SDL_GetTicks();

    if (mMilisegonsActP-mMilisegonsAntP>=SPF)
    {
	    switch(mEstat)
	    {
	        case MENU_PRINCIPAL:        MenuPrincipalP();   break;
	        case MODE_JOC:              ModeJocP();         break;
	        case LLENGUA:               LlenguaP();         break;
                case TEMES:                 TemesP();           break;
	        case PUNTUACIONS:           PuntuacionsP();     break;
	        case NOU_NIVELL:
	        case REINICIALITZA_NIVELL:  NouNivellP();       break;
	        case JUGANT:
	        case INTERCANVI:
	        case DESFA_INTERCANVI:
	        case BUIDANT:
	        case BAIXANT:
	        case REEMPLACANT:
	        case NO_MES_LINIES:
	        case FI_NIVELL:
	        case FI_PARTIDA:            PintaPartida();     break;
	        case RECORD:                RecordP();          break;
	        default:                                        break;

	    }
     	    mMilisegonsAntP = mMilisegonsActP;

     }
}



void MotorTilematch::TeclaAmunt(const SDLKey& tecla)
{
    mFramesTecla=0;
    switch(tecla)
    {
        case GP2X_BUTTON_START:     mTY=false; break;
        case GP2X_BUTTON_UP:        mTAmu=false; break;
        case GP2X_BUTTON_DOWN:      mTAva=false; break;
        case GP2X_BUTTON_LEFT:      mTEsq=false; break;
        case GP2X_BUTTON_RIGHT:     mTDre=false; break;
        case GP2X_BUTTON_A:         mTA=false; break;
        case GP2X_BUTTON_B:         mTB=false; break;
        case GP2X_BUTTON_X:         mTX=false; break;
        case GP2X_BUTTON_Y:         mTY=false; break;
        case GP2X_BUTTON_L:         mTL=false; break;
        case GP2X_BUTTON_R:         mTR=false; break;
	case SDLK_ESCAPE:   mSurt=true; break;
        default: break;
    }
}

void MotorTilematch::mouseDown(int x, int y)
 {
selectedX=x;
selectedY=y;
mCursor->mousePosition(x,y);

                    if (!mPausa)
                    {
                        if (mEstat==JUGANT)
                        {
                            if (!mSel1)
                            {
                                mQuinSel1 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
				mQuinSelY1 = (mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA;
				mQuinSelX1 = (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
                                Mix_PlayChannel(-1, mSoMarca, 0);
                                mSel1 = true;
                            }
                        else if ((mSel1) && ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA==mQuinSel1)  mSel1 = false;

 			else if (mSel1 && !mSel2)
                   	 	{
                      	 	 mQuinSel2 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
				 mQuinSelY2 = (mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA;
				 mQuinSelX2 = (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
				 if (abs(mQuinSel1-mQuinSel2) == 1 || ((abs(mQuinSelY1-mQuinSelY2) == 1) && (abs(mQuinSelX1-mQuinSelX2) == 0)) ) mSel2 = true;
				 else { mQuinSel1 = mQuinSel2;
					mQuinSelY1 = mQuinSelY2;
					mQuinSelX1 = mQuinSelX2;
					mSel1=true;
					mSel2=false;
					}
                      		 }

                        }
                        else
                        {
                            Mix_PlayChannel(-1, mSoNoCanvi, 0);
                        }
                    }
}

void MotorTilematch::mouseUp(int x, int y)
{
selectedX=x;
selectedY=y;


                    if (!mPausa)
                    {
                        if (mEstat==JUGANT)
                        {
                           if (mSel1 && !mSel2)
                   	 	{
				mCursor->mousePosition(x,y);
				
                      	 	 mQuinSel2 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
				 mQuinSelY2 = (mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA;
				 mQuinSelX2 = (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
				 	
				if (abs(mQuinSel1-mQuinSel2) == 1 || ((abs(mQuinSelY1-mQuinSelY2) == 1) && (abs(mQuinSelX1-mQuinSelX2) == 0)) ) mSel2 = true;
 
				else { mQuinSel1 = mQuinSel2;
					mQuinSelY1 = mQuinSelY2;
					mQuinSelX1 = mQuinSelX2;
					mSel1=true;
					mSel2=false;
					}
                      		 }

                        }
                        
                    }
}



void MotorTilematch::TeclaAvall(const SDLKey& tecla)

{
    switch(mEstat)
    {
        case MENU_PRINCIPAL:
        case MODE_JOC:
        case TEMES:
        case LLENGUA:
        case PUNTUACIONS:
        case RECORD:
        {
            switch(tecla)
            {

                case GP2X_BUTTON_UP:        mTAmu=true; break;
                case GP2X_BUTTON_DOWN:      mTAva=true; break;
                case GP2X_BUTTON_UPLEFT:    mTAmuEsq = true; break;
                case GP2X_BUTTON_UPRIGHT:   mTAmuDre = true; break;
                case GP2X_BUTTON_DOWNLEFT:  mTAvaEsq = true; break;
                case GP2X_BUTTON_DOWNRIGHT: mTAvaDre = true; break;
                case GP2X_BUTTON_A:         mTA=true; break;
                case GP2X_BUTTON_B:         mTB=true; break;
                case GP2X_BUTTON_X:         mTX=true; break;
                case GP2X_BUTTON_START:     mTY=true; break;
                case GP2X_BUTTON_L:         mTL=true; break;
                case GP2X_BUTTON_R:         mTR=true; break;
                case GP2X_BUTTON_VOLUP:     mTVolAmu=true; break;
                case GP2X_BUTTON_VOLDOWN:   mTVolAva=true; break;
                default: break;
            }
            break;
        }
        case JUGANT:
        case INTERCANVI:
        case DESFA_INTERCANVI:
        case BUIDANT:
        case BAIXANT:
        case REEMPLACANT:
        {
            switch(tecla)
            {
                case GP2X_BUTTON_LEFT:      mTEsq = true; break;
                case GP2X_BUTTON_RIGHT:     mTDre = true; break;
                case GP2X_BUTTON_UP:        mTAmu = true; break;
                case GP2X_BUTTON_DOWN:      mTAva = true; break;
                case GP2X_BUTTON_UPLEFT:    mTAmuEsq = true; break;
                case GP2X_BUTTON_UPRIGHT:   mTAmuDre = true; break;
                case GP2X_BUTTON_DOWNLEFT:  mTAvaEsq = true; break;
                case GP2X_BUTTON_DOWNRIGHT: mTAvaDre = true; break;
                case GP2X_BUTTON_L:         mTL = true; break;
                case GP2X_BUTTON_R:         mTR = true; break;
                case GP2X_BUTTON_VOLUP:     mTVolAmu=true; break;
                case GP2X_BUTTON_VOLDOWN:   mTVolAva=true; break;
                case GP2X_BUTTON_A:
                case GP2X_BUTTON_B:
                case GP2X_BUTTON_X:
                case GP2X_BUTTON_Y:
                {
                    if (!mPausa)
                    {
                        if (mEstat==JUGANT)
                        {
                            if (!mSel1)
                            {
                                mQuinSel1 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
                                Mix_PlayChannel(-1, mSoMarca, 0);
                                mSel1 = true;
                            }
                            else
                            {
                                if (((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA==mQuinSel1)
                                    mSel1 = false;
                            }
                        }
                        else
                        {
                            Mix_PlayChannel(-1, mSoNoCanvi, 0);
                        }
                    }
                    break;
                }
                case GP2X_BUTTON_START:
                {
                    if (mEstat==JUGANT)
                    {
                        mPausa = !mPausa;
                        if (mPausa) Mix_PlayChannel(2, mSoPausa, 0);
                    }
                    break;
                }
                default: break;
            }
            break;
        }
        default: break;
    }
}


void MotorTilematch::MenuPrincipalA()
{


    if (mFramesTecla>0) mFramesTecla--;
    if (mFramesTecla==0)
    {
       
        if (mTAmu)
        {
            mOpcioMenu--;
            if (mOpcioMenu<0) mOpcioMenu=2;
            Mix_PlayChannel(2, mSoCursor, 0);
            mFramesTecla=RETARD_ESTIC_MENU;
        }
        if (mTAva)
        {
            mOpcioMenu++;
            if (mOpcioMenu>2) mOpcioMenu=0;
            mFramesTecla=RETARD_ESTIC_MENU;
        }
        if (mTA||mTB||mTX||mTY)
        {
            switch(mOpcioMenu)
            {
                case 0:
                {
                    Mix_HaltMusic();
                    mEstat = NOVA_PARTIDA;
                    break;
                }
                case 1:
                {
                    Mix_HaltMusic();
    
                    mEstat = PUNTUACIONS;
                    break;
                }
                case 2:
                {
                    mSurt = true;
                    break;
                }
            }
            mFramesTecla=RETARD_BOTO_MENU;
        }
        if (mTVolAmu)
        {
            mVolum += 8;
            if (mVolum>MIX_MAX_VOLUME) mVolum=MIX_MAX_VOLUME;
            Mix_VolumeMusic(mVolum);
            Mix_Volume(-1, mVolum);
            mFramesTecla=RETARD_ESTIC_MENU;
        }
        if (mTVolAva)
        {
            mVolum -= 8;
            if (mVolum<0) mVolum=0;
            Mix_VolumeMusic(mVolum);
            Mix_Volume(-1, mVolum);
            mFramesTecla=RETARD_ESTIC_MENU;
        }
    }
}


void MotorTilematch::ModeJocA()
{
    mGestorPecesIntro->Actualitza();

    if (mFramesTecla>0) mFramesTecla--;
    if (mFramesTecla==0)
    {
        if (mTAmu)
        {
            if (mModeJoc==MODE_JOC_NORMAL)
                mModeJoc=MODE_JOC_TEMPS;
            else
                mModeJoc--;
            Mix_PlayChannel(2, mSoCursor, 0);
            mFramesTecla=RETARD_ESTIC_MENU;
        }
        if (mTAva)
        {
            mModeJoc++;
            if (mModeJoc>MODE_JOC_TEMPS) mModeJoc=MODE_JOC_NORMAL;
            Mix_PlayChannel(2, mSoCursor, 0);
            mFramesTecla=RETARD_ESTIC_MENU;
        }
        if (mTA||mTB||mTX||mTY)
        {
            mEstat = MENU_PRINCIPAL;
            mFramesTecla=RETARD_BOTO_MENU;
        }
        if (mTVolAmu)
        {
            mVolum += 8;
            if (mVolum>MIX_MAX_VOLUME) mVolum=MIX_MAX_VOLUME;
            Mix_VolumeMusic(mVolum);
            Mix_Volume(-1, mVolum);
            mFramesTecla=RETARD_BOTO_MENU;
        }
        if (mTVolAva)
        {
            mVolum -= 8;
            if (mVolum<0) mVolum=0;
            Mix_VolumeMusic(mVolum);
            Mix_Volume(-1, mVolum);
            mFramesTecla=RETARD_BOTO_MENU;
        }
    }
}


void MotorTilematch::LlenguaA()
{
    mGestorPecesIntro->Actualitza();

    if (mFramesTecla>0) mFramesTecla--;
    if (mFramesTecla==0)
    {
        if (mTAmu)
        {
            if (mLlengua==CAT)
                mLlengua=ANG;
            else
                mLlengua--;
            Mix_PlayChannel(2, mSoCursor, 0);
            mFramesTecla=RETARD_ESTIC_MENU;
        }
        if (mTAva)
        {
            mLlengua++;
            if (mLlengua>ANG) mLlengua=CAT;
            Mix_PlayChannel(2, mSoCursor, 0);
            mFramesTecla=RETARD_ESTIC_MENU;
        }
        if (mTA||mTB||mTX||mTY)
        {
            FILE* arxiu = fopen("data/llengua.tlm", "wb");
            if (arxiu == NULL)
            {
                cerr << "Error llegint <data/llengua.tlm>" << endl;
                exit(1);
            }
            fwrite(&mLlengua, sizeof(mLlengua), 1, arxiu);
            fclose(arxiu);
#ifdef TARGET_GP2X
            sync();
#endif
            mEstat = MENU_PRINCIPAL;
            mFramesTecla=RETARD_BOTO_MENU;
        }
        if (mTVolAmu)
        {
            mVolum += 8;
            if (mVolum>MIX_MAX_VOLUME) mVolum=MIX_MAX_VOLUME;
            Mix_VolumeMusic(mVolum);
            Mix_Volume(-1, mVolum);
            mFramesTecla=RETARD_BOTO_MENU;
        }
        if (mTVolAva)
        {
            mVolum -= 8;
            if (mVolum<0) mVolum=0;
            Mix_VolumeMusic(mVolum);
            Mix_Volume(-1, mVolum);
            mFramesTecla=RETARD_BOTO_MENU;
        }
    }
}


void MotorTilematch::InitTemesA()
{
    mGestorTemes=new GestorTemes();
    mEstat=TEMES;
}


void MotorTilematch::TemesA()
{
    if (mFramesTecla>0) mFramesTecla--;
    if (mFramesTecla==0)
    {
        if (mTA||mTB||mTX||mTY)
        {
            delete mGestorTemes;
            mFramesTecla=RETARD_BOTO_MENU;
            mEstat=MENU_PRINCIPAL;
        }
    }
}


void MotorTilematch::RecordA()
{
    mGestorPecesIntro->Actualitza();

    if (mFramesTecla>0) mFramesTecla--;
    if (mFramesTecla==0)
    {
     
            mRecordActual=mPuntuacions.Afegeix(mModeJoc, "YOU", mPunts, mNivell);
            mPuntuacions.Escriu("data/puntuacions.tlm");
            mEstat = PUNTUACIONS;
            mFramesTecla=RETARD_BOTO_MENU;
     
    }
}


void MotorTilematch::PuntuacionsA()
{
    mGestorPecesIntro->Actualitza();

    if (mFramesTecla>0) mFramesTecla--;
    if (mFramesTecla==0)
    {
              if (mTL&&mTR)
        {
            mPuntuacions.SobreEscriu("data/puntuacions.tlm");
            mFramesTecla=RETARD_BOTO_MENU;
        }
        if (mTA||mTB||mTX||mTY)
        {
            Mix_HaltMusic();
            mEstat = MENU_PRINCIPAL;
            mFramesTecla=RETARD_BOTO_MENU;
        }
        if (mTVolAmu)
        {
            mVolum += 8;
            if (mVolum>MIX_MAX_VOLUME) mVolum=MIX_MAX_VOLUME;
            Mix_VolumeMusic(mVolum);
            Mix_Volume(-1, mVolum);
            mFramesTecla=RETARD_BOTO_MENU;
        }
        if (mTVolAva)
        {
            mVolum -= 8;
            if (mVolum<0) mVolum=0;
            Mix_VolumeMusic(mVolum);
            Mix_Volume(-1, mVolum);
            mFramesTecla=RETARD_BOTO_MENU;
        }
    }
}


void MotorTilematch::NovaPartidaA()
{
    numberOfPieces = 7;
    mPunts = 0;
    mRecordActual = -1;
    mNivell = 0;
    mCursor->Inicialitza();

  
    mTemps = 30;


    if (mModeJoc==MODE_JOC_CENT || mModeJoc==MODE_JOC_TEMPS)
        for (Uint8 i=0; i< numberOfPieces; i++)
        {
            mPecesRestants[i].mAconseguides = 0;
            mPecesRestants[i].mPeca->Aconseguida(false);
        }
    mEstat = NOU_NIVELL;
}


void MotorTilematch::NouNivellA()
{
    mTAmu = mTAva = mTEsq = mTDre = mTAmuEsq = mTAmuDre = mTAvaEsq = mTAvaDre = mTL = mTR = false;

    mPausa = false;
    mMostraPuntsSumats = false;
    mMesMoviments = true;

    mNivell++;
    if (mNivell==7) numberOfPieces++;

    Sint8 taulaTmp[MIDA_TAULERQ];
    for (Uint8 i=0; i<MIDA_TAULERQ; i++) taulaTmp[i] = -1;

    srand(time(NULL));

    for (Uint8 i=0; i<MIDA_TAULERQ; i++)
        mTauler[i] = NULL;

    do
    {
        for (Uint8 i=0; i<MIDA_TAULERQ; i++)
            if (mTauler[i]!=NULL)
            {
                delete mTauler[i];
                mTauler[i] = NULL;
            }

        for (Uint8 i=0; i<MIDA_TAULERQ; i++)
        {
            do
            {
                taulaTmp[i] = 1 + (rand() % numberOfPieces);
            }
            while (HiHaLinia(taulaTmp));
        }

        for (Sint16 i=0; i<MIDA_TAULERQ; i++)
            mTauler[i] = new PecaEnTauler(mOrigenTaulerX + (i%MIDA_TAULER) * MIDA_PECA, mOrigenTaulerY + (i/MIDA_TAULER) * MIDA_PECA, taulaTmp[i], mImgPeces, mSuperficie);
    }
    while (!MesMoviments());
/*
for (Sint16 i=0; i<MIDA_TAULERQ; i++)
	mTauler[i] = new PecaEnTauler(mOrigenTaulerX + (i%MIDA_TAULER) * MIDA_PECA, mOrigenTaulerY + (i/MIDA_TAULER) * MIDA_PECA, 1, mImgPeces, mSuperficie);
*/
    if (mModeJoc==MODE_JOC_NORMAL)
    {
        for (Uint8 i=0; i< numberOfPieces; i++)
        {
            mPecesRestants[i].mRestants = mNivell+2;
            mPecesRestants[i].mAconseguides = 0;
            mPecesRestants[i].mPeca->Aconseguida(false);
        }
    }

    mActivaBaixar = mActivaReemplacar = mActivaFiNivell = mActivaNoMesLinies = mActivaEspecial = true;
    mSel1 = mSel2 = false;

    mPecaDoblePuntuacio = new PecaDoble(2, RESY-36, (rand()% numberOfPieces) + 1, mImgPecesRestants, mSuperficie);
    mPecaDoblePuntuacio->Actualitza();

    mNumBuidades = 0;

 mTemps = 15;
 
    mTempsAct = mTempsAnt = mTempsMostraNumNivell = SDL_GetTicks();
    mSonaBuidant = true;
    mEstat = JUGANT;
}


void MotorTilematch::ReinicialitzaNivellA()
{
    mPausa = false;
    mMostraPuntsSumats = false;
    mMesMoviments = true;

    Sint8 taulaTmp[MIDA_TAULERQ];
    for (Uint8 i=0; i<MIDA_TAULERQ; i++) taulaTmp[i] = -1;

    srand(time(NULL));

    for (Uint8 i=0; i<MIDA_TAULERQ; i++)
        mTauler[i] = NULL;

    do
    {
        for (Uint8 i=0; i<MIDA_TAULERQ; i++)
            if (mTauler[i]!=NULL)
            {
                delete mTauler[i];
                mTauler[i] = NULL;
            }

        for (Uint8 i=0; i<MIDA_TAULERQ; i++)
        {
            do
            {
                taulaTmp[i] = 1 + (rand() % numberOfPieces);
            }
            while (HiHaLinia(taulaTmp));
        }

        for (Sint16 i=0; i<MIDA_TAULERQ; i++)
            mTauler[i] = new PecaEnTauler(mOrigenTaulerX + (i%MIDA_TAULER) * MIDA_PECA, mOrigenTaulerY + (i/MIDA_TAULER) * MIDA_PECA, taulaTmp[i], mImgPeces, mSuperficie);
    }
    while (!MesMoviments());

    mActivaBaixar = mActivaReemplacar = mActivaFiNivell = mActivaNoMesLinies = true;
    mSel1 = mSel2 = false;

    mNumBuidades = 0;
    mTempsAct = mTempsAnt = SDL_GetTicks();
    mSonaBuidant = true;
    mEstat = JUGANT;
}

void MotorTilematch::JugantA()
{
    GestionaTeclesPartida();

    if (!mPausa)
    {
        if (mSel1 && mSel2) mEstat = INTERCANVI;
        for (Uint8 i=0; i<MIDA_TAULERQ; i++)
            if (mTauler[i]!=NULL) mTauler[i]->Actualitza();
    }
}


void MotorTilematch::IntercanviA()
{
    GestionaTeclesPartida();

    if (!mPausa)
    {
        if (mSel1 && mSel2)
        {
            if (abs(mQuinSel1-mQuinSel2) == 1)
            {
                // En horitzontal
                if (mQuinSel1 < mQuinSel2)
                {
                    mTauler[mQuinSel1]->Dreta();
                    mTauler[mQuinSel2]->Esquerra();
                }
                else
                {
                    mTauler[mQuinSel1]->Esquerra();
                    mTauler[mQuinSel2]->Dreta();
                }
            }
            else
            {
                // En vertical
                if (mQuinSel1 < mQuinSel2)
                {
                    mTauler[mQuinSel1]->Avall();
                    mTauler[mQuinSel2]->Amunt();
                }
                else
                {
                    mTauler[mQuinSel1]->Amunt();
                    mTauler[mQuinSel2]->Avall();
                }
            }

            PecaEnTauler* pecaTmp = mTauler[mQuinSel2];
            mTauler[mQuinSel2] = mTauler[mQuinSel1];
            mTauler[mQuinSel1] = pecaTmp;

            mSel1 = mSel2 = false;
        }
        else
        {
            if (mTauler[mQuinSel1]->DonaEstat()==PecaEnTauler::ACTIVA && mTauler[mQuinSel2]->DonaEstat()==PecaEnTauler::ACTIVA)
            {
                CercaLinies();
                if (mNumLinies>0)
                {
                    SumaPunts();
                    if (EsFiNivell())
                    {
                        Mix_PlayChannel(-1, mSoFiNivell, 0);
                        mEstat = FI_NIVELL;
                    }
                    else
                    {
	int a;
             
			if (6-mNivell/2 < 2) a=2;
             
			else a=(6-mNivell/2);
                        mTemps += a; if (mTemps>30) mTemps = 30;
                        mEstat = BUIDANT;
                    }
                }
                else
                {
                    Mix_PlayChannel(-1, mSoNoCanvi, 0);

                    mSel1 = mSel2 = true;
                    mEstat = DESFA_INTERCANVI;
                }
            }
        }

        for (Uint8 i=0; i<MIDA_TAULERQ; i++) mTauler[i]->Actualitza();
    }
}


void MotorTilematch::DesfaIntercanviA()
{
    GestionaTeclesPartida();

    if (!mPausa)
    {
        if (mSel1 && mSel2)
        {
            if (abs(mQuinSel1-mQuinSel2) == 1)
            {
                // En horitzontal
                if (mQuinSel1 < mQuinSel2)
                {
                    mTauler[mQuinSel1]->Dreta();
                    mTauler[mQuinSel2]->Esquerra();
                    mCursor->Esquerra();
                }
                else
                {
                    mTauler[mQuinSel1]->Esquerra();
                    mTauler[mQuinSel2]->Dreta();
                    mCursor->Dreta();
                }
            }
            else
            {
                // En vertical
                if (mQuinSel1 < mQuinSel2)
                {
                    mTauler[mQuinSel1]->Avall();
                    mTauler[mQuinSel2]->Amunt();
                    mCursor->Amunt();
                }
                else
                {
                    mTauler[mQuinSel1]->Amunt();
                    mTauler[mQuinSel2]->Avall();
                    mCursor->Avall();
                }
            }

            PecaEnTauler* pecaTmp = mTauler[mQuinSel2];
            mTauler[mQuinSel2] = mTauler[mQuinSel1];
            mTauler[mQuinSel1] = pecaTmp;

            mSel1 = mSel2 = false;
        }
        else
        {
            if (mTauler[mQuinSel1]->DonaEstat()==PecaEnTauler::ACTIVA && mTauler[mQuinSel2]->DonaEstat()==PecaEnTauler::ACTIVA)
            mEstat = JUGANT;
        }

        for (Uint8 i=0; i<MIDA_TAULERQ; i++) mTauler[i]->Actualitza();
    }
}


void MotorTilematch::BuidantA()
{
    GestionaTeclesPartida();

    if (!mPausa)
    {
        if (mNumBuidades==0) BuidaLinies();

        if (mSonaBuidant)
        {
            Mix_PlayChannel(-1, mSoCanvi, 0);
            mSonaBuidant = false;
        }

        if (mNumBuidades>0)
        {
            bool totesEliminades = true;
            for (Uint8 i=0; i<mNumBuidades && totesEliminades; i++)
            {
                if (mTauler[mPecesEliminades[i]]!=NULL)
                    totesEliminades &= mTauler[mPecesEliminades[i]]->DonaEstat()==PecaEnTauler::MORTA;
            }

            if (totesEliminades)
            {

                for (Uint8 i=0; i<mNumBuidades; i++)
                {
                    delete mTauler[mPecesEliminades[i]];
                    mTauler[mPecesEliminades[i]] = NULL;
                }

                mNumBuidades = 0;
                mSonaBuidant = true;
                mEstat = BAIXANT;
            }
        }

        for (Uint8 i=0; i<MIDA_TAULERQ; i++)
            if (mTauler[i]!=NULL) mTauler[i]->Actualitza();
    }
}


void MotorTilematch::BaixantA()
{
    GestionaTeclesPartida();

    if (!mPausa)
    {
        if (mActivaBaixar) BaixaPeces();

        bool totesAvall = true;
        for (Uint8 i=0; i<MIDA_TAULERQ && totesAvall; i++)
        {
            if (mTauler[i]!=NULL)
                totesAvall &= mTauler[i]->DonaEstat()==PecaEnTauler::ACTIVA;
        }

        if (totesAvall)
        {
            mActivaBaixar = true;
            mEstat = REEMPLACANT;
        }
        else
            mActivaBaixar = false;

        for (Uint8 i=0; i<MIDA_TAULERQ; i++)
            if (mTauler[i]!=NULL) mTauler[i]->Actualitza();
    }
}


void MotorTilematch::ReemplacantA()
{
    GestionaTeclesPartida();

    if (!mPausa)
    {
        if (mActivaReemplacar) ReemplacaPeces();

        bool totesReemplacades = true;
        for (Uint8 i=0; i<MIDA_TAULERQ && totesReemplacades; i++)
            if (mTauler[i]!=NULL)
                totesReemplacades &= mTauler[i]->DonaEstat()==PecaEnTauler::ACTIVA;

        if (totesReemplacades)
        {
            mActivaReemplacar = true;

            CercaLinies();
            if (mNumLinies>0)
            {
                SumaPunts();
                if (EsFiNivell())
                {
                    Mix_PlayChannel(-1, mSoFiNivell, 0);
                    mEstat = FI_NIVELL;
                }
                else
                {
                int a;
             
			if (6-mNivell/2 < 2) a=2;
             
			else a=(6-mNivell/2);
                        mTemps += a; if (mTemps>30) mTemps = 30;
                        
                    mEstat = BUIDANT;
                }
            }
            else
            {
                mMesMoviments = MesMoviments();
                if (mMesMoviments)
                    mEstat = JUGANT;
                else
                {
                    Mix_PlayChannel(-1, mSoNoMesLinies, 0);
                    mTempsNoMesLinies = SDL_GetTicks();
                    SDL_SetAlpha(mImgPeces, SDL_SRCALPHA, 75);
                    mEstat = NO_MES_LINIES;
                }
            }
        }
        else
            mActivaReemplacar = false;

        for (Uint8 i=0; i<MIDA_TAULERQ; i++)
            if (mTauler[i]!=NULL) mTauler[i]->Actualitza();
    }
}


void MotorTilematch::NoMesLiniesA()
{
    if (SDL_GetTicks()-mTempsNoMesLinies>3000)
    {
        Uint8 i;

        if (mActivaNoMesLinies)
            for (i=0; i<MIDA_TAULERQ; i++)
                if (mTauler[i]!=NULL) mTauler[i]->Elimina();

        bool totesEliminades = true;
        for (i=0; i<MIDA_TAULERQ && totesEliminades; i++)
            if (mTauler[i]!=NULL)
                totesEliminades &= mTauler[i]->DonaEstat()==PecaEnTauler::MORTA;

        if (totesEliminades)
        {
            for (i=0; i<MIDA_TAULERQ; i++)
                if (mTauler[i]!=NULL)
                {
                    delete mTauler[i];
                    mTauler[i] = NULL;
                }

            //    delete mPecaDoblePuntuacio;
            //    mPecaDoblePuntuacio = NULL;

            mActivaNoMesLinies = true;
            mEstat = NOU_NIVELL;
        }
        else
            mActivaFiNivell = false;

        for (Uint8 j=0; j<MIDA_TAULERQ; j++)
            if (mTauler[j]!=NULL) mTauler[j]->Actualitza();

        mEstat = REINICIALITZA_NIVELL;
        SDL_SetAlpha(mImgPeces, SDL_SRCALPHA, 255);
    }
}


void MotorTilematch::FiNivellA()
{
    Sint16 i;

    if (mActivaFiNivell)
        for (Sint16 i=0; i<MIDA_TAULERQ; i++)
            if (mTauler[i]!=NULL) mTauler[i]->Elimina();

    bool totesEliminades = true;
    for (i=0; i<MIDA_TAULERQ && totesEliminades; i++)
        if (mTauler[i]!=NULL)
            totesEliminades &= mTauler[i]->DonaEstat()==PecaEnTauler::MORTA;

    if (totesEliminades)
    {
        for (i=0; i<MIDA_TAULERQ; i++)
            if (mTauler[i]!=NULL)
            {
                delete mTauler[i];
                mTauler[i] = NULL;
            }

        delete mPecaDoblePuntuacio;
        mPecaDoblePuntuacio = NULL;

        mActivaFiNivell = true;
        mEstat = NOU_NIVELL;
    }
    else
        mActivaFiNivell = false;

    for (Uint8 j=0; j<MIDA_TAULERQ; j++)
        if (mTauler[j]!=NULL) mTauler[j]->Actualitza();
}


void MotorTilematch::FiPartidaA()
{
    while (Mix_Playing(-1)>0);

    for (Sint16 i=0; i<MIDA_TAULERQ; i++)
        if (mTauler[i]!=NULL)
        {
            delete mTauler[i];
            mTauler[i]=NULL;
        }

    Mix_PlayChannel(-1, mSoFiPartida, 0);

    while (Mix_Playing(-1)>0);

    delete mPecaDoblePuntuacio;
    mPecaDoblePuntuacio = NULL;

    if (mPuntuacions.EsDins(mModeJoc,mPunts))
    {
        mPosicioEnNom = 0;
        mEstat = RECORD;
    }
    else
    {
        mEstat = MENU_PRINCIPAL;
    }

    // Buida la cua d'events (per si es prem alguna tecla)
    SDL_Event event;
    while(SDL_PollEvent(&event));
    mTAmu = mTAva = mTEsq = mTDre = mTAmuEsq = mTAmuDre = mTAvaEsq = mTAvaDre = mTL = mTR = mTVolAmu = mTVolAva = mTStart = mTSelect = mTA = mTB = mTX = mTY = false;

    SDL_SetAlpha(mImgPeces, SDL_SRCALPHA, 255);
}


void MotorTilematch::SurtPartidaA()
{
    for (Sint16 i=0; i<MIDA_TAULERQ; i++)
        if (mTauler[i]!=NULL)
        {
            delete mTauler[i];
            mTauler[i]=NULL;
        }

    delete mPecaDoblePuntuacio;
    mPecaDoblePuntuacio = NULL;

    mEstat = MENU_PRINCIPAL;
}


void MotorTilematch::MenuPrincipalP()
{
    char modeJoc[40];

    SDL_BlitSurface(mImgFons, NULL, mSuperficie, NULL);

    mGestorPecesIntro->Pinta();

    mText->Escriu(RESX/2, RESY/2 - 60, sNovaPartida[mLlengua], CENTREH);
    mText->Escriu(RESX/2, RESY/2 - 40, sPuntuacions[mLlengua], CENTREH);
    mText->Escriu(RESX/2, RESY/2 - 20, sSortir[mLlengua], CENTREH);
    mText->Escriu(RESX/2, RESY/2 + mOpcioMenu*20-60, "*                *", CENTREH);

    
    mText->Escriu(RESX-7, 55, "v0.6", DRETA|AVALL);
}


void MotorTilematch::ModeJocP()
{
    SDL_BlitSurface(mImgFons, NULL, mSuperficie, NULL);

    mGestorPecesIntro->Pinta();

    mText->Escriu(RESX/2, RESY/2 - 40, sModeJoc[mLlengua], CENTREH);
    mText->Escriu(RESX/2, RESY/2 - 10, sModeNormal[mLlengua], CENTREH);
    mText->Escriu(RESX/2, RESY/2, sModeCent[mLlengua], CENTREH);
    mText->Escriu(RESX/2, RESY/2 + 10, sModeTemps[mLlengua], CENTREH);
    mText->Escriu(RESX/2, RESY/2 + mModeJoc*10-10, "*                 *", CENTREH);

    mText->Escriu(RESX-7, 55, "v0.6", DRETA|AVALL);
}


void MotorTilematch::TemesP()
{
    static char tema[80];
    SDL_BlitSurface(mImgFons, NULL, mSuperficie, NULL);

    Sint16 oriX=20, oriY=50;
    Uint8 numTemes = mGestorTemes->DonaNumTemes();
    char** llista = mGestorTemes->DonaLlistaTemes();
    for (Uint8 i=0; i<numTemes; i++)
    {
        if (i<15)
        {
            sprintf(tema, "%s", llista[i]);
            for (Uint8 j=0; j<strlen(llista[i]); j++)
                tema[j]=toupper(tema[j]);
            if (strlen(tema)>20)
            {
                tema[17]=tema[18]=tema[19]='.';
                tema[20]='\0';
            }
            mText->Escriu(oriX, oriY+i*10, tema);
        }
    }

    static SDL_Rect pecaEnImg, posicio;
    pecaEnImg.x=pecaEnImg.y=0;
    pecaEnImg.w=pecaEnImg.h=MIDA_PECA;
    posicio.x=200;
    posicio.y=100;
    for (Uint8 i=0; i< numberOfPieces; i++)
    {
        if (i%2==0 && i!=0)
        {
            posicio.x=200;
            posicio.y+=MIDA_PECA;
        }
        SDL_BlitSurface(mImgPeces, &pecaEnImg, mSuperficie, &posicio);
        pecaEnImg.x+=MIDA_PECA;
        posicio.x+=MIDA_PECA;
    }

    mText->Escriu(RESX-7, 55, "v0.6", DRETA|AVALL);
}


void MotorTilematch::LlenguaP()
{
    SDL_BlitSurface(mImgFons, NULL, mSuperficie, NULL);

    mGestorPecesIntro->Pinta();

    mText->Escriu(RESX/2, RESY/2 - 50, sLlengua[mLlengua], CENTREH);
    mText->Escriu(RESX/2, RESY/2 - 20, sLlengues[CAT], CENTREH);
    mText->Escriu(RESX/2, RESY/2 - 10, sLlengues[EUS], CENTREH);
    mText->Escriu(RESX/2, RESY/2, sLlengues[GAL], CENTREH);
    mText->Escriu(RESX/2, RESY/2 + 10, sLlengues[CAS], CENTREH);
    mText->Escriu(RESX/2, RESY/2 + 20, sLlengues[ANG], CENTREH);
    mText->Escriu(RESX/2, RESY/2 + mLlengua*10-20, "*              *", CENTREH);

    mText->Escriu(RESX-7, 55, "v0.6", DRETA|AVALL);
}


void MotorTilematch::PuntuacionsP()
{
    char puntuacio[50], puntuacions[50];

    Uint8 oriY = RESY/2 - MIDA_CARACTER*2;

    SDL_BlitSurface(mImgFons, NULL, mSuperficie, NULL);

    mGestorPecesIntro->Pinta();

   sprintf( puntuacions, "%s", sPuntuacions[mLlengua]);

    mText->Escriu(RESX/2, 10, puntuacions, CENTREH|CENTREV);
    mText->Escriu(RESX/2,30, sTitolPuntuacions[mLlengua], CENTREH|CENTREV);

    Puntuacions::Linia* punts = mPuntuacions.Dona();
    for (Uint8 i=mModeJoc*10; i<mModeJoc*10+10; i++)
    {
        if ((Sint8)i==mRecordActual)
            sprintf(puntuacio, "\\ %2d %3s    %07d   %02d  [", i-(10*mModeJoc)+1, punts[i].mNom, punts[i].mPunts, punts[i].mNivell);
        else
            sprintf(puntuacio, " %2d %3s    %07d   %02d  ", i-(10*mModeJoc)+1, punts[i].mNom, punts[i].mPunts, punts[i].mNivell);
        mText->Escriu(RESX/2, oriY+100 + (i-(10*mModeJoc)+1)*MIDA_CARACTER, puntuacio, CENTREH|CENTREV);
    }


   

}


void MotorTilematch::RecordP()
{
    SDL_BlitSurface(mImgFons, NULL, mSuperficie, NULL);

    mGestorPecesIntro->Pinta();

    char puntuacio[8];
    sprintf(puntuacio, "%d", mPunts);
    mText->Escriu(RESX/2, RESY/2 - MIDA_CARACTER*5, sPunts[mLlengua], CENTREH|CENTREV);
    mText->Escriu(RESX/2, RESY/2 - MIDA_CARACTER*4+2, puntuacio, CENTREH|CENTREV);
    mText->Escriu(RESX/2, RESY/2, mNom, CENTREH|CENTREV);
    switch(mPosicioEnNom)
    {
        case 0: mText->Escriu(RESX/2, RESY/2+MIDA_CARACTER-1, "-  ", CENTREH|CENTREV); break;
        case 1: mText->Escriu(RESX/2, RESY/2+MIDA_CARACTER-1, " - ", CENTREH|CENTREV); break;
        case 2: mText->Escriu(RESX/2, RESY/2+MIDA_CARACTER-1, "  -", CENTREH|CENTREV); break;
    }

    mText->Escriu(RESX/2, RESY - 4*MIDA_CARACTER, sInfoIntroNomL1[mLlengua], CENTREH|CENTREV);
    mText->Escriu(RESX/2, RESY - 3*MIDA_CARACTER, sInfoIntroNomL2[mLlengua], CENTREH|CENTREV);
    mText->Escriu(RESX/2, RESY - 2*MIDA_CARACTER, sInfoIntroNomL3[mLlengua], CENTREH|CENTREV);

    mText->Escriu(RESX-7, 55, "v0.6", DRETA|AVALL);
}


void MotorTilematch::NouNivellP()
{
}


void MotorTilematch::PintaPartida()
{
    static char punts[8], puntsSumats[8], nivell[3], temps[4], restants[3], obj[3], fps[4], numNivell[10];
    Uint8 i;

    // Fons
    SDL_FillRect(mSuperficie, &mRequadreInfo, SDL_MapRGB(mSuperficie->format, 100, 0, 0));
    SDL_FillRect(mSuperficie, &mRequadreJoc, SDL_MapRGB(mSuperficie->format, 180, 30, 30));

    // Puntuaci�
    mText->Escriu(350, RESY-60, sPunts[mLlengua]);
    sprintf(punts, "%07d", mPunts);
    mText->Escriu(330, RESY-30, punts);
    if (mMostraPuntsSumats)
    {
        if (SDL_GetTicks()-mTempsPuntsSumats<500)
        {
            sprintf(puntsSumats, "+%d", mPuntsSumats);
            mText->Escriu(4+7*MIDA_CARACTER, 20, puntsSumats, DRETA);
        }
        else mMostraPuntsSumats = false;
    }

    // Nivell
    if (mModeJoc!=MODE_JOC_TEMPS)
    {
        mText->Escriu(10, RESY-60, sNivell[mLlengua]);
        sprintf(nivell, "%d", mNivell);
        mText->Escriu(100, RESY-60, nivell);
    }

    // Temps
    mText->Escriu(20, (MIDA_TAULER*MIDA_PECA)+15, sTemps[mLlengua]);
    sprintf(temps, "%d", mTemps);
    mText->Escriu(35, (MIDA_TAULER*MIDA_PECA)+35, temps);

    // Objectiu
    if (mModeJoc==MODE_JOC_NORMAL)
    {
        mText->Escriu(200, RESY-60, sObj[mLlengua]);
        sprintf(obj, "%d", mNivell+2);
        mText->Escriu(200, RESY-30, obj);
    }

    // Peces restants
    for (i=0; i< numberOfPieces; i++)
    {
        mPecesRestants[i].mPeca->Pinta();
        sprintf(restants, "%3d", mPecesRestants[i].mAconseguides);
        mText->Escriu(105+i*(MIDA_PECA_RESTANT+15), (MIDA_TAULER*MIDA_PECA)+15, restants);
    }

    // x2
    mText->Escriu(MIDA_PECA_RESTANT+4, RESY-30, "X2");
    if (mPecaDoblePuntuacio!=NULL) mPecaDoblePuntuacio->Pinta();

    if (!mPausa)
    {
        if (mSel1)
        {
            mSeleccionatDest.x = mCursor->DonaX()-1;
            mSeleccionatDest.y = mCursor->DonaY()-1;
            SDL_BlitSurface(mImgCursor, &mSeleccionatOri, mSuperficie, &mSeleccionatDest);
        }

        for (i=0; i<MIDA_TAULERQ; i++)
            if (mTauler[i]!=NULL) mTauler[i]->Pinta();

        if (!mSel1 && mMesMoviments && mEstat!=FI_PARTIDA) mCursor->Pinta();
        if (mEstat!=FI_PARTIDA && SDL_GetTicks()-mTempsMostraNumNivell<3000)
        {
            sprintf(numNivell, "%s %d", sNivell[mLlengua], mNivell);
            mText->Escriu(mOrigenTaulerX+4*MIDA_PECA, mOrigenTaulerY+(MIDA_TAULER*MIDA_PECA/2), numNivell, CENTREH|CENTREV);
        }
    }
    else
    {
        if (mEstat!=FI_PARTIDA) mText->Escriu(mOrigenTaulerX+4*MIDA_PECA, mOrigenTaulerY+(MIDA_TAULER*MIDA_PECA/2), sPausa[mLlengua], CENTREH|CENTREV);
    }

    if (!mMesMoviments)
    {
        mText->Escriu(mOrigenTaulerX+4*MIDA_PECA, mOrigenTaulerY+(MIDA_TAULER*MIDA_PECA/2), sNoMesLinies[mLlengua], CENTREH|CENTREV);
    }

    if (mEstat==FI_PARTIDA)
    {
        mText->Escriu(mOrigenTaulerX+4*MIDA_PECA, mOrigenTaulerY+(MIDA_TAULER*MIDA_PECA/2), sFiPartida[mLlengua], CENTREH|CENTREV);
    }

    // FPS
    if (mMostraFPS)
    {
        sprintf(fps, "%d", DonaFPS());
        mText->Escriu(mOrigenTaulerX, RESY-(MIDA_CARACTER<<1), "FPS", DRETA);
        mText->Escriu(mOrigenTaulerX, RESY-MIDA_CARACTER, fps, DRETA);
    }
}


bool MotorTilematch::HiHaLinia(Sint8* taula)
{
    // Cerca horitzontal

    Uint8 i=0;
    Sint8 xIni, yIni, xAct, yAct, xMin, xMax, yMin, yMax;

    bool trobat = false, surt;

    while (taula[i]!=-1 && i<MIDA_TAULERQ && !trobat)
    {
        xIni = i%8;
        xMin = xIni; xMax = xIni;

        // Cap a l'esquerra
        xAct = xIni-1;
        surt = false;
        while (xAct>=0 && !surt)
        {
            if (taula[i+xAct-xIni] == taula[i])
                xMin = xAct;
            else
                surt = true;
            xAct--;
        }

        // Cap a la dreta
        xAct = xIni+1;
        surt = false;
        while (xAct<MIDA_TAULER && !surt)
        {
            if (taula[i+xAct-xIni] == taula[i])
                xMax = xAct;
            else
                surt = true;
            xAct++;
        }

        trobat = xMax-xMin > 1;
        i++;
    }

    if (trobat) return true;

    // Cerca VERTICAL

    i = 0;
    while (taula[i]!=-1 && i<MIDA_TAULERQ && !trobat)
    {
        yIni = i/8;
        yAct = yIni;
        yMin = yIni; yMax = yIni;

        // Cap amunt
        yAct = yIni-1;
        surt = false;
        while (yAct>=0 && !surt)
        {
            if (taula[i + (yAct-yIni)*MIDA_TAULER] == taula[i])
                yMin = yAct;
            else
                surt = true;
            yAct--;
        }

        // Cap avall
        yAct = yIni+1;
        surt = false;
        while (yAct<MIDA_TAULER && !surt)
        {
            if (taula[i + (yAct-yIni)*MIDA_TAULER] == taula[i])
                yMax = yAct;
            else
                surt = true;
            yAct++;
        }

        trobat = yMax-yMin > 1;
        i++;
    }

    return trobat;
}


void MotorTilematch::CercaLinies()
{
    Sint16 xIni, yIni, xAct, yAct, xMin, xMax, yMin, yMax;
    Uint8 i = 0;
    bool surt = false, trobat;

    mNumLinies = 0;

    while (i<MIDA_TAULERQ)
    {
        // Cerca horitzontal

        xIni = i%8;
        xMin = xIni; xMax = xIni;

        // Cap a l'esquerra
        xAct = xIni-1;
        surt = false;
        while (xAct>=0 && !surt)
        {
            if (mTauler[i+xAct-xIni]->DonaTipus() == mTauler[i]->DonaTipus())
                xMin = xAct;
            else
                surt = true;
            xAct--;
        }

        // Cap a la dreta
        xAct = xIni+1;
        surt = false;
        while (xAct<MIDA_TAULER && !surt)
        {
            if (mTauler[i+xAct-xIni]->DonaTipus() == mTauler[i]->DonaTipus())
                xMax = xAct;
            else
                surt = true;
            xAct++;
        }

        trobat = xMax-xMin > 1; // Diu si hi ha una l�ia horitzontal en aquell punt

        if (trobat)
        {
            // Comprova si aquella l�ia ja � present al vector de l�ies
            trobat = false;
            Uint8 inici = i-((i%8)-xMin);
            Uint8 mida = xMax-xMin+1;

            for (Uint8 j=0; j<mNumLinies && !trobat; j++)
                trobat = (mLinies[j].mInici==inici && mLinies[j].mMida==mida && mLinies[j].mOrientacio==0);

            if (!trobat)
            {
                mLinies[mNumLinies].mInici = inici;
                mLinies[mNumLinies].mMida = mida;
                mLinies[mNumLinies].mOrientacio = 0;
                mLinies[mNumLinies].mTipus = mTauler[i]->DonaTipus();
                mNumLinies++;
            }
        }

        // Cerca vertical

        yIni = i/8;
        yMin = yIni; yMax = yIni;

        // Cap amunt
        yAct = yIni-1;
        surt = false;
        while (yAct>=0 && !surt)
        {
            if (mTauler[i+(yAct-yIni)*8]->DonaTipus() == mTauler[i]->DonaTipus())
                yMin = yAct;
            else
                surt = true;
            yAct--;
        }

        // Cap avall
        yAct = yIni+1;
        surt = false;
        while (yAct<MIDA_TAULER && !surt)
        {
            if (mTauler[i+(yAct-yIni)*8]->DonaTipus() == mTauler[i]->DonaTipus())
                yMax = yAct;
            else
                surt = true;
            yAct++;
        }

        trobat = yMax-yMin > 1; // Diu si hi ha una l�ia vertical en aquell punt

        if (trobat)
        {
            // Comprova si aquella l�ia ja � present al vector de l�ies
            trobat = false;
            Uint8 inici = i-((i/8 - yMin)*8);
            Uint8 mida = yMax-yMin+1;

            for (Uint8 j=0; j<mNumLinies && !trobat; j++)
                trobat = (mLinies[j].mInici==inici && mLinies[j].mMida==mida && mLinies[j].mOrientacio==1);

            if (!trobat)
            {
                mLinies[mNumLinies].mInici = inici;
                mLinies[mNumLinies].mMida = mida;
                mLinies[mNumLinies].mOrientacio = 1;
                mLinies[mNumLinies].mTipus = mTauler[i]->DonaTipus();
                mNumLinies++;
            }
        }

        i++;
    }
}


void MotorTilematch::BuidaLinies()
{
    mNumBuidades = 0;

    for (Uint8 i=0; i<mNumLinies; i++)
    {
        if (mLinies[i].mOrientacio == 0) // Horitzontal
        {
            for (Uint8 j=mLinies[i].mInici; j < mLinies[i].mInici + mLinies[i].mMida; j++)
            {
                if (mTauler[j] != NULL)
                {
                    mTauler[j]->Elimina();
                    mPecesEliminades[mNumBuidades++] = j;
                }
            }
        }
        else
        {
            for (Uint8 j=mLinies[i].mInici; j < mLinies[i].mInici + mLinies[i].mMida*MIDA_TAULER; j+=MIDA_TAULER)
            {
                if (mTauler[j] != NULL)
                {
                    mTauler[j]->Elimina();
                    mPecesEliminades[mNumBuidades++] = j;
                }
            }
        }
    }
}


void MotorTilematch::BaixaPeces()
{
    // Crea una taula parallela a l'original on, per a cada pe�, indica quantes posicions ha de baixar

    Uint8 taulerTmp[MIDA_TAULERQ];
    Sint8 i, j, desti;

    for (i=0; i<MIDA_TAULERQ; i++) taulerTmp[i] = 0;

    for (i=MIDA_TAULERQ-1; i>=MIDA_TAULER; i--)
    {
        if (mTauler[i] == NULL)
        {
            for (j=i-MIDA_TAULER; j>=0; j-=MIDA_TAULER)
            {
                if (mTauler[j] != NULL)
                    taulerTmp[j]++;
            }
        }
    }

    for (i=MIDA_TAULERQ-1; i>=0; i--)
    {
        if (taulerTmp[i]>0)
        {
            desti = i + taulerTmp[i]*MIDA_TAULER;
            mTauler[desti] = mTauler[i];
            mTauler[desti]->Avall(taulerTmp[i]);
            mTauler[i] = NULL;
        }
    }
}


void MotorTilematch::ReemplacaPeces()
{
    for (Uint8 i=0; i<MIDA_TAULERQ; i++)
        if (mTauler[i]==NULL)
            mTauler[i] = new PecaEnTauler(mOrigenTaulerX + (i%MIDA_TAULER) * MIDA_PECA, mOrigenTaulerY + (i/MIDA_TAULER) * MIDA_PECA, 1 + (rand() % numberOfPieces), mImgPeces, mSuperficie);
}


void MotorTilematch::ControlTemps()
{
    if (!mPausa)
    {
        mTempsAct = SDL_GetTicks();

        if (mTempsAct-mTempsAnt > 1000)
        {
            mTemps--;
            if (mTemps<=5) Mix_PlayChannel(-1, mSoDeuSegons, 0);
            if (mTemps==0)
            {
                SDL_SetAlpha(mImgPeces, SDL_SRCALPHA, 75);
                mEstat = FI_PARTIDA;
            }
            mTempsAnt = SDL_GetTicks();
        }
    }
}


bool MotorTilematch::MesMoviments()
{
    bool mesMov = false;
    Sint16 pos;

    Sint8 taulaTmp[MIDA_TAULERQ];
    for (Uint8 i=0; i<MIDA_TAULERQ; i++)
        taulaTmp[i] = mTauler[i]->DonaTipus();

    pos=0;
    while (!mesMov && pos<MIDA_TAULERQ)
    {
        Uint8 tipusTmp = taulaTmp[pos];
        taulaTmp[pos] = taulaTmp[pos+1];
        taulaTmp[pos+1] = tipusTmp;

        mesMov = HiHaLinia(taulaTmp);

        taulaTmp[pos+1]=taulaTmp[pos];
        taulaTmp[pos]=tipusTmp;

        // Incrementa la posici�(columna), i si � arriba al l�it, baixa una fila
        pos++;
        if (((pos+1)%MIDA_TAULER)==0) pos++;
    }

    pos=0;
    while (!mesMov && pos<MIDA_TAULERQ)
    {
        Uint8 tipusTmp = taulaTmp[pos];
        taulaTmp[pos] = taulaTmp[pos+MIDA_TAULER];
        taulaTmp[pos+MIDA_TAULER] = tipusTmp;

        mesMov = HiHaLinia(taulaTmp);

        taulaTmp[pos+MIDA_TAULER]=taulaTmp[pos];
        taulaTmp[pos]=tipusTmp;

        // Incrementa la posici�(fila), i si � arriba al l�it, augmenta una columna
        pos+=MIDA_TAULER;
        if (pos>=MIDA_TAULERQ-1)
            pos = MIDA_TAULERQ;
        else if ((pos+MIDA_TAULER)>=MIDA_TAULERQ)
        {
            pos = pos-MIDA_TAULERQ+MIDA_TAULER+1;
        }
    }

    return mesMov;
}


bool MotorTilematch::EsFiNivell()
{
    bool fiNivell=false;

    switch(mModeJoc)
    {
        case MODE_JOC_NORMAL:
        {
            fiNivell=true;
            for (Uint8 i=0; i< numberOfPieces && fiNivell; i++)
                fiNivell &= mPecesRestants[i].mRestants==0;
            break;
        }
        case MODE_JOC_CENT:
        {
            fiNivell=false;
            for (Uint8 i=0; i< numberOfPieces; i++)
            {
                fiNivell |= mPecesRestants[i].mAconseguides>=100;
                if (mPecesRestants[i].mAconseguides>=100) mPecesRestants[i].mAconseguides-=100;
            }
            break;
        }
    }

    return fiNivell;
}


void MotorTilematch::SumaPunts()
{
    Uint8 multiplicador;
    mPuntsSumats = 0;
    mMostraPuntsSumats = false;
    for (Uint8 i=0; i<mNumLinies; i++)
    {
        multiplicador = (mPecaDoblePuntuacio->DonaTipus() == mLinies[i].mTipus) ? 2 : 1;
        mPuntsSumats += mNivell*mLinies[i].mMida*10*(i+1)*multiplicador;
        mPunts += mNivell*mLinies[i].mMida*10*(i+1)*multiplicador;
        mPecesRestants[mLinies[i].mTipus-1].mAconseguides += mLinies[i].mMida;
        if (mModeJoc==MODE_JOC_NORMAL)
        {
            if (mPecesRestants[mLinies[i].mTipus-1].mRestants>0)
                mPecesRestants[mLinies[i].mTipus-1].mRestants -= mLinies[i].mMida;
            if (mPecesRestants[mLinies[i].mTipus-1].mRestants<=0)
            {
                mPecesRestants[mLinies[i].mTipus-1].mRestants = 0;
                mPecesRestants[mLinies[i].mTipus-1].mPeca->Aconseguida();
            }
        }
    }
    mMostraPuntsSumats = true;
    mTempsPuntsSumats = SDL_GetTicks();
}


void MotorTilematch::GestionaTeclesPartida()
{
    Uint32 dif=SDL_GetTicks()-mTempsTecla;
    if (dif>RETARD_TECLA)
    {
        if (mTL) mMostraFPS = !mMostraFPS;

        if (mTL && mTR)
        {
            SDL_SetAlpha(mImgPeces, SDL_SRCALPHA, 75);
            mEstat = FI_PARTIDA;
            mTempsTecla = SDL_GetTicks();
            return;
        }
/*
        if ((mTAmuEsq&&!mTEsq) || (mTAmuEsq&&mTAmu) || mTAmu || (mTAmu&&mTAmuDre))
        {
            if (!mPausa)
            {
                if (mCursor->Amunt())
                {
                    Mix_PlayChannel(2, mSoCursor, 0);
                    if (mSel1 && !mSel2)
                    {
                        mQuinSel2 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
                        mSel2 = true;
                    }
                }
                else mSel1 = mSel2 = false;
            }

            mTempsTecla = SDL_GetTicks();
            return;
        }

        if ((mTAvaDre&&!mTDre) || (mTAvaDre&&mTAva) || mTAva || (mTAva&&mTAvaEsq))
        {
            if (!mPausa)
            {
                if (mCursor->Avall())
                {
                    Mix_PlayChannel(2, mSoCursor, 0);
                    if (mSel1 && !mSel2)
                    {
                        mQuinSel2 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
                        mSel2 = true;
                    }
                }
                else mSel1 = mSel2 = false;
            }

            mTempsTecla = SDL_GetTicks();
            return;
        }

        if ((mTAvaEsq&&!mTAva) || (mTAvaEsq&&mTEsq) || mTEsq || (mTEsq&&mTAmuEsq))
        {
            if (!mPausa)
            {
                if (mCursor->Esquerra())
                {
                    Mix_PlayChannel(2, mSoCursor, 0);
                    if (mSel1 && !mSel2)
                    {
                        mQuinSel2 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
                        mSel2 = true;
                    }
                }
                else mSel1 = mSel2 = false;
            }

            mTempsTecla = SDL_GetTicks();
            return;
        }

        if ((mTAmuDre&&!mTAmu) || (mTAmuDre&&mTDre) || mTDre || (mTDre&&mTAvaDre))
        {
            if (!mPausa)
            {
                if (mCursor->Dreta())
                {
                    Mix_PlayChannel(2, mSoCursor, 0);
                    if (mSel1 && !mSel2)
                    {
                        mQuinSel2 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
                        mSel2 = true;
                    }
                }
                else mSel1 = mSel2 = false;
            }

            mTempsTecla = SDL_GetTicks();
            return;
        }
*/

        if (mTAmu || (mTAmuEsq && mTAnt==0 && dif<(RETARD_TECLA<<1)) || (mTAmuDre && mTAnt==0 && dif<(RETARD_TECLA<<1)))
        {
            if (!mPausa)
            {
                if (mCursor->Amunt())
                {
                    Mix_PlayChannel(2, mSoCursor, 0);
                    if (mSel1 && !mSel2)
                    {
                        mQuinSel2 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
                        mSel2 = true;
                    }
                }
                else mSel1 = mSel2 = false;
            }

            mTAnt = 0; // 0=amunt, 1=avall, 2=esquerra, 3=dreta
            mTempsTecla = SDL_GetTicks();
            return;
        }

        if (mTAva || (mTAvaEsq && mTAnt==1 && dif<(RETARD_TECLA<<1)) || (mTAvaDre && mTAnt==1 && dif<(RETARD_TECLA<<1)))
        {
            if (!mPausa)
            {
                if (mCursor->Avall())
                {
                    Mix_PlayChannel(2, mSoCursor, 0);
                    if (mSel1 && !mSel2)
                    {
                        mQuinSel2 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
                        mSel2 = true;
                    }
                }
                else mSel1 = mSel2 = false;
            }

            mTAnt = 1; // 0=amunt, 1=avall, 2=esquerra, 3=dreta
            mTempsTecla = SDL_GetTicks();
            return;
        }

        if (mTEsq || (mTAvaEsq && mTAnt==2 && dif<(RETARD_TECLA<<1)) || (mTAmuEsq && mTAnt==2 && dif<(RETARD_TECLA<<1)))
        {
            if (!mPausa)
            {
                if (mCursor->Esquerra())
                {
                    Mix_PlayChannel(2, mSoCursor, 0);
                    if (mSel1 && !mSel2)
                    {
                        mQuinSel2 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
                        mSel2 = true;
                    }
                }
                else mSel1 = mSel2 = false;
            }

            mTAnt = 2; // 0=amunt, 1=avall, 2=esquerra, 3=dreta
            mTempsTecla = SDL_GetTicks();
            return;
        }

        if (mTDre || (mTAvaDre && mTAnt==3 && dif<(RETARD_TECLA<<1)) || (mTAmuDre && mTAnt==3 && dif<(RETARD_TECLA<<1)))
        {
            if (!mPausa)
            {
                if (mCursor->Dreta())
                {
                    Mix_PlayChannel(2, mSoCursor, 0);
                    if (mSel1 && !mSel2)
                    {
                        mQuinSel2 = ((mCursor->DonaY() - mOrigenTaulerY)/MIDA_PECA)*MIDA_TAULER + (mCursor->DonaX() - mOrigenTaulerX)/MIDA_PECA;
                        mSel2 = true;
                    }
                }
                else mSel1 = mSel2 = false;
            }

            mTAnt = 3; // 0=amunt, 1=avall, 2=esquerra, 3=dreta
            mTempsTecla = SDL_GetTicks();
            return;
        }

        if (mTVolAmu)
        {
            mVolum += 8;
            if (mVolum>MIX_MAX_VOLUME) mVolum=MIX_MAX_VOLUME;
            Mix_VolumeMusic(mVolum);
            Mix_Volume(-1, mVolum);
            mFramesTecla=RETARD_BOTO_MENU;
        }
        if (mTVolAva)
        {
            mVolum -= 8;
            if (mVolum<0) mVolum=0;
            Mix_VolumeMusic(mVolum);
            Mix_Volume(-1, mVolum);
            mFramesTecla=RETARD_BOTO_MENU;
        }
    }
}
