#include "PecaPartida.h"

PecaPartida::PecaPartida(Sint16 x, Sint16 y, Uint8 tipus, SDL_Surface* imgPeces, SDL_Surface* superficie) : Peca(x, y, tipus, imgPeces, superficie)
{
    mDestiX = x;
    mDestiY = y;
}

PecaPartida::~PecaPartida()
{
    //dtor
}

void PecaPartida::Pinta()
{
    if (mEstat != MORTA)
        SDL_BlitSurface(mImgPeces, &mPecaEnImg, mSuperficie, &mPosicio);
}


void PecaPartida::Actualitza()
{
    switch (mEstat)
    {
        case INICIALITZACIO:
        {
            mTempsAnt = SDL_GetTicks();
            mEstat = NAIXEMENT;
            break;
        }
        case NAIXEMENT:
        {
            mTempsAct = SDL_GetTicks();
            if (mTempsAct-mTempsAnt > 50)
            {
                mPecaEnImg.y = 0;
                mEstat = ACTIVA;
            }
            else if (mTempsAct-mTempsAnt > 40)
                mPecaEnImg.y = MIDA_PECA;
            else if (mTempsAct-mTempsAnt > 30)
                mPecaEnImg.y = MIDA_PECA<<1;
            else if (mTempsAct-mTempsAnt > 20)
                mPecaEnImg.y = MIDA_PECA*3;
            else if (mTempsAct-mTempsAnt > 10)
                mPecaEnImg.y = MIDA_PECA<<2;
            break;
        }
        case DESPLACANT:
        {
            mTempsAct = SDL_GetTicks();

            if (mPosicio.x!=mDestiX || mPosicio.y!=mDestiY)
            {
                if (mPosicio.x < mDestiX) mPosicio.x += 30;
                if (mPosicio.x > mDestiX) mPosicio.x -= 30;
                if (mPosicio.y < mDestiY) mPosicio.y += 30;
                if (mPosicio.y > mDestiY) mPosicio.y -= 30;
            }
            else
                mEstat = ACTIVA;
            break;
        }
        case INIELIMINANT:
        {
            mTempsAct = mTempsAnt = SDL_GetTicks();
            mEstat = ELIMINANT;
            break;
        }
        case ELIMINANT:
        {
            mTempsAct = SDL_GetTicks();
            if (mTempsAct-mTempsAnt > 60)
                mEstat = MORTA;
            else if (mTempsAct-mTempsAnt > 50)
                mPecaEnImg.y = MIDA_PECA<<2;
            else if (mTempsAct-mTempsAnt > 40)
                mPecaEnImg.y = MIDA_PECA*3;
            else if (mTempsAct-mTempsAnt > 30)
                mPecaEnImg.y = MIDA_PECA<<1;
            else if (mTempsAct-mTempsAnt > 20)
                mPecaEnImg.y = MIDA_PECA;
            else if (mTempsAct-mTempsAnt > 10)
                mPecaEnImg.y = 0;
            break;
        }
        default: break;
    }
}


void PecaPartida::Esquerra(Uint8 quant)
{
    mDestiX = mPosicio.x - MIDA_PECA*quant;
    mEstat = DESPLACANT;
}


void PecaPartida::Dreta(Uint8 quant)
{
    mDestiX = mPosicio.x + MIDA_PECA*quant;
    mEstat = DESPLACANT;
}


void PecaPartida::Amunt(Uint8 quant)
{
    mDestiY = mPosicio.y - MIDA_PECA*quant;
    mEstat = DESPLACANT;
}


void PecaPartida::Avall(Uint8 quant)
{
    mDestiY = mPosicio.y + MIDA_PECA*quant;
    mEstat = DESPLACANT;
}


