#ifndef PECAPARTIDA_H
#define PECAPARTIDA_H

#include "Peca.h"


class PecaPartida : public Peca
{
    public:
		PecaPartida(Sint16 x, Sint16 y, Uint8 tipus, SDL_Surface* imgPeces, SDL_Surface* superficie);
        virtual ~PecaPartida();

		virtual void Pinta();
		virtual void Actualitza();

        void Esquerra(Uint8 quant = 1);
		void Dreta(Uint8 quant = 1);
		void Amunt(Uint8 quant = 1);
		void Avall(Uint8 quant = 1);

		inline Sint16 DonaX() { return mPosicio.x; };
		inline Sint16 DonaY() { return mPosicio.y; };

		enum Estat {INICIALITZACIO, NAIXEMENT, ACTIVA, DESPLACANT, INIELIMINANT, ELIMINANT, MORTA};
		Estat DonaEstat() { return mEstat; };
		void Elimina() { mEstat = INIELIMINANT; };

    protected:
		Estat mEstat;
		Sint16 mDestiX;
		Sint16 mDestiY;
};

#endif // PECAPARTIDA_H
