#include "Puntuacions.h"

#include <string.h>
#include <stdio.h>
#include <iostream>
#ifdef TARGET_GP2X
#include <unistd.h>
#endif

using namespace std;


void Puntuacions::Llegeix(char* nomArxiu)
{
    FILE* arxiu = fopen(nomArxiu, "rb");
    if (arxiu == NULL)
    {
        cerr << "Error llegint <data/puntuacions.tlm>: " << SDL_GetError() << endl;
        exit(1);
    }

    for (Uint8 i=0; i<30; i++)
    {
        fread( mPuntuacions[i].mNom, sizeof(char)*4, 1, arxiu);
        fread( &(mPuntuacions[i].mPunts), sizeof(Uint32), 1, arxiu);
        fread( &(mPuntuacions[i].mNivell), sizeof(Uint8), 1, arxiu);
    }
    fclose(arxiu);
}


void Puntuacions::Escriu(char* nomArxiu)
{
    FILE* arxiu = fopen(nomArxiu, "wb");
    if (arxiu == NULL)
    {
        cerr << "Error escrivint <data/puntuacions.tlm>: " << SDL_GetError() << endl;
        exit(1);
    }
    for (Uint8 i=0; i<30; i++)
    {
        fwrite( mPuntuacions[i].mNom, sizeof(char)*4, 1, arxiu);
        fwrite( &(mPuntuacions[i].mPunts), sizeof(Uint32), 1, arxiu);
        fwrite( &(mPuntuacions[i].mNivell), sizeof(Uint8), 1, arxiu);
    }
    fclose(arxiu);
#ifdef TARGET_GP2X
    sync();
#endif
}


void Puntuacions::SobreEscriu(char* nomArxiu)
{
    for (Uint8 i=0; i<30; i++)
    {
        sprintf(mPuntuacions[i].mNom, "MIQ");
        mPuntuacions[i].mPunts = 0;
        mPuntuacions[i].mNivell = 1;
    }

    Escriu(nomArxiu);
}


Sint8 Puntuacions::Afegeix(Sint8 mode, char* nom, Uint32 punts, Uint8 nivell)
{
    Sint8 pos;
    bool trobat=false;

    for (pos=mode*10; pos<mode*10+10 && !trobat; pos++)
        trobat = punts >= mPuntuacions[pos].mPunts;

    if (trobat)
    {
        pos--;
        Uint8 j;
        for (j=mode*10+9; j>pos; j--)
        {
            strcpy(mPuntuacions[j].mNom, mPuntuacions[j-1].mNom);
            mPuntuacions[j].mPunts = mPuntuacions[j-1].mPunts;
            mPuntuacions[j].mNivell = mPuntuacions[j-1].mNivell;
        }

        strcpy(mPuntuacions[pos].mNom, nom);
        mPuntuacions[pos].mPunts = punts;
        mPuntuacions[pos].mNivell = nivell;
    }
    else pos=-1;

    return pos;
}


bool Puntuacions::EsDins(Sint8 mode, Uint32 punts)
{
    bool trobat = false;

    for (Uint8 i=mode*10; i<mode*10+10 && !trobat; i++)
        trobat = punts >= mPuntuacions[i].mPunts;

    return trobat;
}
